<?php

//index.php

//  include header file 
include('header.php');

?>

<!-- --------------------------------------------------------------------------------------------------------------- -->

<div class="container" style="margin-top:30px">
  <div class="card">
  	
    <div class="card-header">
      <div class="row">
        <div class="col-md-9">Overall Student Attendance Status</div>
      </div>
    </div>

  	<div class="card-body">
  		<div class="table-responsive">
    
        <table class="table table-striped table-bordered" id="student_table">
          <thead>
            <tr>
              <th>Student Name</th>
              <th>Roll Number</th>
              <th>Course</th>
              <th>Faculty</th>
              <th>Attendance Percentage</th>
              <th>Report</th>
            </tr>
          </thead>

          <tbody>
          </tbody>
        </table>

  		</div>
  	</div>
  </div>
</div>

</body>
</html>

<!-- ---------------------------------------------------------------------------------------------- -->

<!-- make report -->
<script type="text/javascript" src="../js/bootstrap-datepicker.js"></script>
<link rel="stylesheet" href="../css/datepicker.css" />

<style>
    .datepicker
    {
      z-index: 1600 !important; /* has to be larger than 1050 */
    }
</style>


<div class="modal" id="formModal">
  <div class="modal-dialog">
    <div class="modal-content">

      <!-- Modal Header -->
      <div class="modal-header">
        <h4 class="modal-title">Make Report</h4>
        <button type="button" class="close" data-dismiss="modal">&times;</button>
      </div>

      <!-- Modal body -->
      <div class="modal-body">
        <div class="form-group">
          <select name="report_action" id="report_action" class="form-control">
            <option value="pdf_report">PDF Report</option>
            <option value="chart_report">Chart Report</option>
          </select>
        </div>

        <div class="form-group">
          <div class="input-daterange">
            <input type="text" name="from_date" id="from_date" class="form-control" placeholder="From Date" readonly />
            <span id="error_from_date" class="text-danger"></span>
            <br />
            <input type="text" name="to_date" id="to_date" class="form-control" placeholder="To Date" readonly />
            <span id="error_to_date" class="text-danger"></span>
          </div>
        </div>
      
      </div>
      
      <!-- Modal footer -->
      <div class="modal-footer">
        <input type="hidden" name="student_id" id="student_id" />
        <button type="button" name="create_report" id="create_report" class="btn btn-success btn-sm">Create Report</button>
        <button type="button" class="btn btn-danger btn-sm" data-dismiss="modal">Close</button>
      </div>

    </div>
  </div>
</div>

<!-- --------------------------------------------------------------------------------------------------- -->

<script>
$(document).ready(function(){
	 
   // call attendance action file
   var dataTable = $('#student_table').DataTable(
    {
    "processing":true,
    "serverSide":true,
    "order":[],
    "ajax":{
      url:"attendance_action.php",
      type:"POST",
      data:
      {
        action:'index_fetch'
      }
    }
   });

// -------------------------------------------------------------------------------------------------

   // for taking date as input
   $('.input-daterange').datepicker({
    todayBtn:"linked",
    format:'yyyy-mm-dd',
    autoclose:true,
    container: '#formModal modal-body'
   });

   
   // on clicking report button
   $(document).on('click', '.report_button', function(){
    var student_id = $(this).data('student_id');
    $('#student_id').val(student_id);
    $('#formModal').modal('show');
   });



  // create report
   $('#create_report').click(function(){
  
    var student_id = $('#student_id').val();
    var from_date = $('#from_date').val();
    var to_date = $('#to_date').val();
  
    var error = 0;
  
    var action = $('#report_action').val();
  
  // from date is empty
    if(from_date == '')
    {
      $('#error_from_date').text('From Date is Required');
      error++;
    }
    else
    {
      $('#error_from_date').text('');
    }

    // to date is empty
    if(to_date == '')
    {
      $('#error_to_date').text("To Date is Required");
      error++;
    }
    else
    {
      $('#error_to_date').text('');
    }

    // no error
    if(error == 0)
    {
      $('#from_date').val('');
      $('#to_date').val('');
      $('#formModal').modal('hide');
      
      // if report
      if(action == 'pdf_report')
      {
        window.open("report.php?action=student_report&student_id="+student_id+"&from_date="+from_date+"&to_date="+to_date);
      }
      
      // if chart
      if(action == 'chart_report')
      {
        location.href = "chart.php?action=student_chart&student_id="+student_id+"&from_date="+from_date+"&to_date="+to_date;
      }
    }

   });

});

</script>